<template >
  <v-ons-page>
    <notifications
      group="new-message"
      position="bottom center"
      width="100%"
      classes="my-notification-style"
    />

    <v-ons-tabbar swipeable position="top" :tabs="tabs" :visible="true" :index.sync="activeIndex"></v-ons-tabbar>
  </v-ons-page>
</template>

<script>
import Vue from "vue";
import "onsenui/css/onsenui.css";
import "onsenui/css/onsen-css-components.css";
import VueOnsen from "vue-onsenui/esm";
import OnsenComponents from "~/components/Onsen";
import Message from "~/components/Message";
import Wallet from "~/components/Wallet";
import Setting from "~/components/Setting";
import utils from "../assets/utils";
import { mapGetters, mapActions } from "vuex";
import Vuelidate from "vuelidate";
import { required, minLength, between } from "vuelidate/lib/validators";
import Notifications from "vue-notification";

Vue.use(Vuelidate);
Vue.use(VueOnsen);
Vue.use(Notifications);
Object.values(OnsenComponents).forEach(c => Vue.component(c.name, c));

export default {
  components: {
    Message,
    Wallet,
    Setting
  },
  data() {
    return {
      activeIndex: 0,
      tabs: [
        {
          icon: this.md() ? null : "ion-ios-chatboxes",
          label: "Message",
          page: Message,
          // badge: 0,
          key: "message"
        },
        {
          icon: this.md() ? null : "ion-ios-wallet",
          label: "Wallet",
          page: Wallet,

          key: "wallet"
        },
        {
          icon: this.md() ? null : "ion-ios-settings",
          label: "Settings",
          page: Setting,
          key: "setting"
        }
      ]
    };
  },
  beforeRouteEnter(to, from, next) {
    next(vm => {
      if (!from || !from.name) return;
      vm.prevRoute = from;
      if (to && to.query.tabIndex) {
        vm.activeIndex = parseInt(to.query.tabIndex);
      } else if (from.name.split("-")[0] === "setting") {
        vm.activeIndex = 2;
      } else if (from.name.split("-")[0] === "wallet") {
        vm.activeIndex = 1;
      }
    });
  },
  methods: {
    ...mapActions({
      addWallet: "wallet/addWallet",
      updateNetwork: "chat/updateNetwork",
      setUIReady: "chat/setUIReady"
    }),
    md() {
      return this.$ons.platform.isAndroid();
    },
    hello() {
      console.log("hello");
    }
  },
  computed: {
    ...mapGetters({
      getWallet: "wallet/getWallet",
      isUIReady: "chat/isUIReady",
      getNetwork: "chat/getNetwork"
    }),
    title() {
      return this.tabs[this.activeIndex].label;
    }
  },
  async mounted() {
    let self = this;
    if (!this.isUIReady) this.$router.push("/loading");
    self.setUIReady();
    if (!this.getWallet) {
      const wallet = utils.loadWallet();
      if (wallet) {
        this.addWallet(wallet);
        console.log("Wallet added to vuex store.");
      }
    }

    let checkServerStatus = setInterval(async () => {
      let lastUpdatedTimestamp = this.getNetwork.timestamp;
      let shouldUpdate = false;
      let isServerActive = await utils.isServerActive()
      if (!isServerActive) shouldUpdate = true;
      if (lastUpdatedTimestamp < Date.now() - 120000) shouldUpdate = true;
      // console.log(`Should update server: ${shouldUpdate}`)
      if (shouldUpdate) {
        let randomHost = await utils.getRandomHost();
        console.log("Updating Network");
        self.updateNetwork(randomHost);
        utils.updateHost(`${randomHost.ip}:${randomHost.port}`);
      }
    }, 10000);
  }
};
</script>

<style>
#main {
  height: 100vh;
}
.page__background {
  background-color: #ffffff;
}
.username-input {
  height: 40px;
  width: 90%;
  max-width: 250px;
  padding: 5px 10px;
  background: #fff;
  border: 1px solid #dddddd;
  border-radius: 5px;
  margin: 20px;
}
h1 {
  font-size: 27px;
  color: #333;
  margin: 30px;
}
.default-btn {
  background: #43b8e7;
  border-radius: 30px;
  padding: 5px;
  font-weight: bolder;
  font-size: 13px;
  width: 160px;
  text-align: center;
  cursor: pointer;
}
.toolbar__center {
  text-align: center;
}

.my-notification-style {
  width: 100%;
  padding: 10px;
  margin: 0 5px 5px;
  border-left: 5px solid #187fe7;
  background: rgb(245, 245, 245);
}
.my-notification-style .notification-title {
  font-size: 13px;
  font-weight: bold;
  color: #0076ff;
}

.my-notification-style .notification-content {
  font-size: 12px;
  font-weight: normal;
  color: #333;
  margin-top: 5px;
}
</style>
